---
title: text-combine-upright
slug: Web/CSS/text-combine-upright
tags:
  - CSS
  - CSS Property
  - CSS Writing Modes
  - Experimental
  - Reference
  - 'recipe:css-property'
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>text-combine-upright</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> property sets the combination of characters into the space of a single character.</span> If the combined text is wider than 1em, the user agent must fit the contents within 1em. The resulting composition is treated as a single upright glyph for layout and decoration. This property only has an effect in vertical writing modes.</p>

<p>This is used to produce an effect that is known as tate-chū-yoko (<span lang="ja">縦中横</span>) in Japanese, or as <span lang="zh-Hant">直書橫向</span> in Chinese.</p>

<pre class="brush:css no-line-numbers notranslate">/* Keyword values */
text-combine-upright: none;
text-combine-upright: all;

/* Digits values */
text-combine-upright: digits;     /* fits 2 consecutive digits horizontally inside vertical text */
text-combine-upright: digits 4;   /* fits up to 4 consecutive digits horizontally inside vertical text */

/* Global values */
text-combine-upright: inherit;
text-combine-upright: initial;
text-combine-upright: unset;
</pre>

<h2 id="Syntax">Syntax</h2>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>none</code></dt>
 <dd>There is no special processing.</dd>
 <dt><code>all</code></dt>
 <dd>Attempts to typeset all consecutive characters within the box horizontally, such that they take up the space of a single character within the vertical line of the box.</dd>
 <dt><code>digits &lt;integer&gt;?</code></dt>
 <dd>Attempts to display a sequence of consecutive ASCII digits (U+0030–U+0039) that has as many or fewer characters than the specified integer, such that it takes up the space of a single character within the vertical line box. If the integer is omitted, it computes to 2. Integers outside the range of 2-4 are invalid.</dd>
</dl>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{CSSInfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Digits">Digits</h3>

<p>The digits value requires less markup than the all value when digits are being combined, but it is currently not very widely supported by browsers.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p lang="ja" class="exampleText"&gt;平成20年4月16日に&lt;/p&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">.exampleText {
  writing-mode: vertical-lr;
  text-combine-upright: digits 2;
  font: 36px serif;
}</pre>

<h4 id="Results">Results</h4>

<p>{{EmbedLiveSample("Digits", 100, 350, "https://mdn.mozillademos.org/files/12127/tate-chu-yoko.png")}}</p>

<h3 id="All">All</h3>

<p>The all value requires markup around every piece of horizontal text, but it is currently supported by more browsers than the digits value.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;p lang="zh-Hant"&gt;民國&lt;span class="num"&gt;105&lt;/span
&gt;年&lt;span class="num"&gt;4&lt;/span
&gt;月&lt;span class="num"&gt;29&lt;/span&gt;日&lt;/p&gt;
</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">html { writing-mode: vertical-rl; font: 24px serif }
.num { text-combine-upright: all }
</pre>

<h4 id="Results_2">Results</h4>

<p>{{EmbedLiveSample("All", 250, 300, "https://mdn.mozillademos.org/files/13096/text-combine-upright-all.png")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSS4 Writing Modes", "#propdef-text-combine-upright", "text-combine-upright")}}</td>
   <td>{{Spec2("CSS4 Writing Modes")}}</td>
   <td>Add <code>digits</code> value</td>
  </tr>
  <tr>
   <td>{{SpecName("CSS3 Writing Modes", "#propdef-text-combine-upright", "text-combine-upright")}}</td>
   <td>{{Spec2("CSS3 Writing Modes")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.text-combine-upright")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("writing-mode")}}, {{cssxref("text-orientation")}}</li>
</ul>
